using System;
using System.Linq;
using System.Windows.Media;
using Styx;
using Styx.Common;
using Styx.Plugins;
using Styx.WoWInternals.WoWObjects;

namespace PotionOfLuck {
    public class PotionOfLuck : HBPlugin {

        // ===========================================================
        // Constants
        // ===========================================================

        // ===========================================================
        // Fields
        // ===========================================================

        public static LocalPlayer Me = StyxWoW.Me;

        public static WoWItem PotionofLuckItem;

        // ===========================================================
        // Constructors
        // ===========================================================

        // ===========================================================
        // Getter & Setter
        // ===========================================================

        // ===========================================================
        // Methods for/from SuperClass/Interfaces
        // ===========================================================

        public override string Name {
            get { return "Potion of TF"; }
        }

        public override string Author {
            get { return "andygami > Moded by UndoneLyric"; }
        }

        public override Version Version {
            get { return new Version(1, 0); }
        }


        public override void Pulse() {
            if(!HasPotionofLuckItem()) {
                return;
            }

            if(!CanUsePotionofLuck()) {
                return;
            }

            if(HasPotionofLuckBuff()) {
                return;
            }

            if(IsPotionofLuckOnCooldown()) {
                return;
            }

            UsePotionofLuck();

            CustomNormalLog("Potion Of TF buff is now active.");
        }

        // ===========================================================
        // Methods
        // ===========================================================

        public void CustomNormalLog(string message, params object[] args) {
            Logging.Write(Colors.DeepSkyBlue, "[Potion of Luck]: " + message, args);
        }

        public static bool IsViable(WoWObject pWoWObject) {
            return (pWoWObject != null) && pWoWObject.IsValid;
        }

        public static bool HasPotionofLuckItem() {
            PotionofLuckItem = Me.BagItems.FirstOrDefault(item => item.Entry == 58488);

            return PotionofLuckItem != null;
        }

        public static bool CanUsePotionofLuck() {
            return IsViable(Me) && !Me.Mounted && !Me.IsDead && !Me.InVehicle && !Me.IsChanneling && !Me.IsFlying && !Me.IsCasting && !Me.OnTaxi;
        }

        public static bool HasPotionofLuckBuff() {
            return Me.HasAura(80263);
        }

        public static void UsePotionofLuck() {
            PotionofLuckItem.Use();
        }

        public static bool IsPotionofLuckOnCooldown() {
            StyxWoW.Sleep(20000);
            return PotionofLuckItem.Cooldown > 0;
        }

        // ===========================================================
        // Inner and Anonymous Classes
        // ===========================================================


    }
}